package io

import (
	"io"
	"context"
)

type WrappedIO struct {
	stdin  io.Reader
	stdout io.Writer
	closer context.CancelFunc
}

func (wio *WrappedIO) Read(p []byte) (n int, err error) {
	return wio.stdin.Read(p)
}

func (wio *WrappedIO) Write(p []byte) (n int, err error) {
	return wio.stdout.Write(p)
}

func (wio *WrappedIO) Close() (err error) {
	wio.closer()
	return io.EOF
}
